@ECHO OFF

SetLocal ENABLEEXTENSIONS

:: PostMach - Yet Another AD Migration Utility
:: Gerald W. Gaston - created: 20030625
:: Version: 1.0  [20030625] Created
:: Version: 1.1  [20030919] Updated - Uses PostMigMachChk.exe
::                          instead of reg.exe for main work.
:: Version: 1.3  [20060321] Updated version # to match PostMigMachChk.exe

::Usage (All Usage lines MUST start with ::!:):
::!:
::!: POSTMACH v1.3 - Yet Another AD Migration Utility
::!:
::!: Usage: POSTMACH file_with_PC_names
::!:
::!: This script is used to verify that PCs have been migrated to the 
::!: target domain. It will also change the default domain to the target
::!: domain for the next logon.
::!:
::!: NOTE: This doesn't stop someone from selecting another domain...
::!: So if they are determine to logon to the previous domain they can.
::!:
::!: Email any questions/comments to gwgaston@yahoo.com, or STF8B.
::!:

:: Notes:
:: ---------------------
:: This script is for W2K+ CMD only. It will not work with WIN95CMD or 
:: CMD from ReactOS. Due to some extended features, this script will most 
:: likely not run with the current 4NT/TCMD from JP Software without 
:: modification. Yes one could use KIX, PL, VBS, or <insert fav here> 
:: script also for this task. If you want this in another scripting language,
:: please have at it.
:: 
:: One comment on using WSH/WMI: WMI exposes much that can often be 
:: difficult to get at otherwise. Fortunately what we are doing here
:: doesn't fall into that catagory. Yes WMI does provide access to the
:: registry via StdRegProv. But it is slower AND requires that the WMI
:: service is running. On my first run of a VBScript version of this,
:: the first remote PC I queried had WMI hosed. -GWG
::
:: Dependencies:
:: ---------------------
:: PostMigMachChk.EXE - Program that does the work...
::                      Expected to be in the CWD that this script is ran in.
::
:: PING.EXE           - MS external utility. Used to verify host is up. 
::                      Expected to be in the path.
::
:: FINDSTR.EXE        - MS external utility. Used for various parsing tasks.	
::
::
:: Windows 2000 is required to run this script.
::
 
::Set DEBUG=YeahBuddy
Set strVersion=1.30
Set panswer=

:: ***** Customize Section *****
:: *

Set TargetDomain=ADDOMAIN

:: *
:: ***** End Customize Section *****


:: Resist any urge to put a colon before NOJPCLI
If NOT "%@EVAL[1+1]" == "2" Goto NOJPCLI

Iff Exist @NAME[%0].btm then 
  Call @NAME[%0].btm
  Goto :L8R
Else
  CMD /C "%0" %*
::  @Echo.&Echo.This CMD version of %@UPPER[%@NAME[%0]] will not run under 4NT/TCMD and
::  @Echo.a BTM version of this batch file could not be found. Please 
::  @Echo.locate a BTM version or use CMD.EXE instead. Sorry! 
  Goto :L8R
EndIff

:NOJPCLI

Set CD=
If defined CD Goto :Arg1Chk
@Echo.
@Echo.ERROR: %~n0 v%strVersion% requires Window 2000 or later.
@Echo.       Please get with the program.
@Echo.
Title POSTMACH v%strVersion%: Aborting - W2K or later required
Goto :L8R

:Arg1Chk
Title Checking Args...
If DEFINED DEBUG @Echo.Checking arguments...
set arg1=%1
If NOT DEFINED arg1 Goto :Syntax
If "A%arg1:~0,1%" == "A?" Goto :Syntax
If "A%arg1:~0,1%" == "A*" Goto :Syntax
If "A%arg1:~0,2%" == "A-?" Goto :Syntax
If "A%arg1:~0,2%" == "A/?" Goto :Syntax
If /I "A%arg1:~0,2%" == "A-h" Goto :Syntax
If /I "A%arg1:~0,2%" == "A/h" Goto :Syntax

Set SvrFile=%1

:Arg2Chk
If NOT "A%2" == "A" goto :Syntax


:LocSupFiles
If exist STOP.IT (
 Del /F /Q STOP.IT > nul 2>&1
)
:: Locate suporting files...
Title Locating support files...
If DEFINED DEBUG @Echo.Locating support files...
Set PostMMC=PostMigMachChk.exe
If NOT exist %PostMMC% (Call :MissingFiles PostMigMachChk.exe & Goto :L8R)

:DefFiles
Title Defining default file paths and int vars...
If DEFINED DEBUG @Echo.Defining default file paths and int vars...
Set ERRORLOG=.\POSTMACHErr.txt
Set GOODUNSLOG=.\POSTMACHGood.txt
Set PMtemptime=
Call :TempTime PMtemptime
Set TmpProcessFile=.\POSTMACH%PMtemptime%.tmp
If Not Exist %TmpProcessFile% Goto :SetInitStuff
Ping -n 62 127.0.0.1 > nul 2>&1  
Set PMtemptime=
Call :TempTime PMtemptime
Set TmpProcessFile=.\POSTMACH%PMtemptime%.tmp
If Exist %TmpProcessFile% (
  Set TmpProcessFile=
  @Echo.&Echo.Can't create unique temp file&Echo.
  Title POSTMACH v%strVersion%: Can't create unique temp file
  Goto :L8R
)

:SetInitStuff
@Echo.> %TmpProcessFile%
If NOT Exist %TmpProcessFile% (
  Set TmpProcessFile=
  @Echo.&Echo.Can't create unique temp file&Echo.
  Title POSTMACH v%strVersion%: Can't create unique temp file
  Goto :L8R
)
Set panswer=
Set hostcnt=0
Set goodcnt=0
Set errcnt=0
Set downcnt=0
Set WinlogonKey=HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\Winlogon
Set DefDomainVal=DefaultDomainName
::Set PCPDomainVal=CachePrimaryDomain
Set logformat=TXT
:: Get pretty date
For /F "tokens=*" %%J in ('date /t') do Set xdate=%%J

If NOT DEFINED SvrFile goto :Syntax
Title Running away with your wife...

:XPchk
:: This check is for XP or 2003 since the output of time /t
:: is different for them
Set runningXP=Y
Set mORnot=

:: This assumes default time settings and calling CMD's int time. 
If DEFINED DEBUG @Echo.Checking LOCAL OS version...
VER | findstr "XP 5.2." > nul 2>&1
If ERRORLEVEL 1 (Set runningXP=N & Set mORnot=m)

If exist %SvrFile% Goto :Errlogchk
@Echo.&Echo.Can't locate the input file:&Echo.&Echo   %SvrFile%&Echo.
@Echo.Please specify a file that contains a list of PCs.&Echo.
Title POSTMACH v%strVersion%: Can't locate input file
Goto :L8R

:Errlogchk
Set panswer=
If NOT exist %ERRORLOG% Goto :Goodlogchk
Title ALERT - Input required!
@Echo.&Echo.POSTMACH Error log file exists: %ERRORLOG%
Set /p panswer=Do you want to [A]ppend, [O]verwrite or [Q]uit?
If /I "A%panswer:~0,1%" == "AA" (
 @Echo.&Echo.Append mode selected...&Echo.
 Title POSTMACH v%strVersion%: Append mode selected...
 Goto :Goodlogchk
)
If /I "A%panswer:~0,1%" == "AO" (
 @Echo.&Echo.Removing POSTMACH error log file: %ERRORLOG%...&Echo.
 Del /F %ERRORLOG% > nul 2>&1
  Title POSTMACH v%strVersion%: Removing error log file...
 Goto :Errlogchk
)
If /I "A%panswer:~0,1%" == "AQ" (
 @Echo.&Echo.Exiting POSTMACH...&Echo.
 Title POSTMACH v%strVersion%: Aborting - Error log file exits
 Goto :L8R
)

:Goodlogchk
Set panswer=
If NOT exist %GOODUNSLOG% Goto :DoIT
Title ALERT - Input required!
@Echo.&Echo.The log file of POSTMACH processed PCs already exists: %GOODUNSLOG%
Set /p panswer=Do you want to [A]ppend, [O]verwrite or [Q]uit?
If /I "A%panswer:~0,1%" == "AA" (
 @Echo.&Echo.Append mode selected...&Echo.
 Title POSTMACH v%strVersion%: Append mode selected...
 Goto :DoIT
)
If /I "A%panswer:~0,1%" == "AO" (
 @Echo.&Echo.Removing existing post migration log file: %GOODUNSLOG%...&Echo.
 Del /F %GOODUNSLOG% > nul 2>&1
  Title POSTMACH v%strVersion%: Removing existing post migration log file...
 Goto :Goodlogchk
)
If /I "A%panswer:~0,1%" == "AQ" (
 @Echo.&Echo.Exiting POSTMACH...&Echo.
 Title POSTMACH v%strVersion%: Aborting - Post Migration log file exits
 Goto :L8R
)

:DoIT
@Echo.
Title POSTMACH v%strVersion%: Running
@Echo.POSTMACH v%strVersion%
@Echo.
@Echo.Processing file: %SvrFile%
@Echo.
For /F "tokens=*" %%J in ('time /t') do set xtime=%%J%mORnot%
For /F "eol=; tokens=1" %%S IN (%SvrFile%) do (If NOT Defined STOPITNOW call :ChkHost %%S)
For /F "tokens=*" %%J in ('time /t') do set xtime=%%J%mORnot%
If %hostcnt% GTR 0 (
@Echo.------------------------------------------------------------------------------
)
If NOT Defined STOPITNOW Goto :WrapitUP4um
@Echo.
@Echo.STOP flag file encountered... Shutting down. 
:WrapitUP4um
@Echo.
If %hostcnt% EQU 0 @Echo.%hostcnt% hostnames were processed.
If %hostcnt% EQU 1 @Echo.%hostcnt% hostname was processed.
If %hostcnt% GTR 1 @Echo.%hostcnt% hostnames were processed.
If %downcnt% EQU 1 @Echo.%downcnt% host was offline.
If %downcnt% GTR 1 @Echo.%downcnt% hosts were offline.
If %errcnt% EQU 1 @Echo.%errcnt% host could NOT be verified as migrated (this includes any hosts offline).
If %errcnt% GTR 1 @Echo.%errcnt% hosts could NOT be verified as migrated (this includes any hosts offline).
If %goodcnt% EQU 1 @Echo.%goodcnt% host was migrated and is ready for logon.
If %goodcnt% GTR 1 @Echo.%goodcnt% hosts were migrated and are ready for logon.
If %goodcnt% GTR 0 (
@Echo.&Echo.One or more PCs were migrated and are ready for logon.. Please see log file:
@Echo.  %GOODUNSLOG%
)
If %errcnt% GTR 0 (
@Echo.&Echo.Problems encountered. Please see error log file:
@Echo.  %ERRORLOG%
)
@Echo.
@Echo.POSTMACH v%strVersion%: Finished processing %SvrFile%
Goto :Bye

:ChkHost
If exist STOP.IT (
 Title STOP Flag Encountered: Shutting Down...
 Set STOPITNOW=Y
 Del /F /Q STOP.IT > nul 2>&1
 Goto :EOF
)
Set targethost=%1
If Defined targethost Set targethost=%targethost:\=%
If Not Defined targethost Goto :EOF
@Echo.------------------------------------------------------------------------------

:HootaGamba 
Title Pinging: %targethost%
@Echo.Working on host: %targethost%
@Echo.Started: %xdate%%xtime%
If NOT DEFINED targethost goto :EOF

Set /A hostcnt=%hostcnt%+1

:: Grab the pretty date and time again.
For /F "tokens=*" %%J in ('DATE /t') do Set xdate=%%J
For /F "tokens=*" %%J in ('time /t') do set xtime=%%J%mORnot%


:PingChk
ping -n 2 %targethost% | findstr /LI "ttl=" > nul 2>&1
If %errorlevel% EQU 1 Goto :NOGO
:: Else all is cool and we can...
Title Pinging: %targethost% - UP
@Echo. + Pinged target host... %targethost% is UP.
Goto :Process

:NOGO
@Echo.%targethost%: %xdate%%xtime% - [1] Could not resolve hostname or host offline.>> %ERRORLOG%
set /a downcnt=%downcnt%+1
set /a errcnt=%errcnt%+1
Title Pinging: %targethost% - DOWN
@Echo. - Can NOT ping target host... %targethost% is DOWN.
For /F "tokens=*" %%J in ('time /t') do set xtime=%%J%mORnot%
Goto :EOF

:Process

%PostMMC% /M %targethost% /T %TargetDomain% /SET
set perrlevel=%errorlevel%
If "%perrlevel%" == "0" Goto :MigSuccess

set /a errcnt=%errcnt%+1

If NOT "A%perrlevel%" == "A1" Goto :Chk2
If "%logformat%" == "TXT" (
   @Echo.%targethost%: %xdate%%xtime% - [1] Could not resolve host or host offline.>> %ERRORLOG%
) Else (
  @Echo.%targethost%,1,Could not resolve host or host offline.>> %ERRORLOG%
)
Goto :EndChkHost

:Chk2
set /a errcodechk="%perrlevel% | 2"
If NOT "A%errcodechk%" == "A%perrlevel%" Goto :Chk4
If "%logformat%" == "TXT" (
   @Echo.%targethost%: %xdate%%xtime% - [2] Can not access. Non-NT host or locked down.>> %ERRORLOG%
) Else (
  @Echo.%targethost%,2,Can not access - Non-NT host or locked down>> %ERRORLOG%
)

:Chk4
set /a errcodechk="%perrlevel% | 4"
If NOT "A%errcodechk%" == "A%perrlevel%" Goto :Chk8
If "%logformat%" == "TXT" (
   @Echo.%targethost%: %xdate%%xtime% - [4] NetBIOS name does not match.>> %ERRORLOG%
) Else (
  @Echo.%targethost%,4,NetBIOS name does not match>> %ERRORLOG%
)

:Chk8
set /a errcodechk="%perrlevel% | 8"
If NOT "A%errcodechk%" == "A%perrlevel%" Goto :Chk16
If "%logformat%" == "TXT" (
   @Echo.%targethost%: %xdate%%xtime% - [8] Remote PC is NOT in %TargetDomain% domain.>> %ERRORLOG%
) Else (
  @Echo.%targethost%,8,Remote PC is NOT in %TargetDomain% domain>> %ERRORLOG%
)

:Chk16
set /a errcodechk="%perrlevel% | 16"
If NOT "A%errcodechk%" == "A%perrlevel%" Goto :Chk32
If "%logformat%" == "TXT" (
   @Echo.%targethost%: %xdate%%xtime% - [16] Access denied to remote registry.>> %ERRORLOG%
) Else (
  @Echo.%targethost%,16,Could not access remote registry>> %ERRORLOG%
)

:Chk32
set /a errcodechk="%perrlevel% | 32"
If NOT "A%errcodechk%" == "A%perrlevel%" Goto :Chk64
If "%logformat%" == "TXT" (
   @Echo.%targethost%: %xdate%%xtime% - [32] Could not verify current default domain name.>> %ERRORLOG%
) Else (
  @Echo.%targethost%,32,Could not verify current default domain name>> %ERRORLOG%
)

:Chk64
set /a errcodechk="%perrlevel% | 64"
If NOT "A%errcodechk%" == "A%perrlevel%" Goto :EndChkHost
If "%logformat%" == "TXT" (
   @Echo.%targethost%: %xdate%%xtime% - [64] Could not change the default domain name.>> %ERRORLOG%
) Else (
  @Echo.%targethost%,64,Could not change the default domain name>> %ERRORLOG%
)
Goto :EndChkHost

:MigSuccess
@Echo.%targethost%>> %GOODUNSLOG%
set /a goodcnt=%goodcnt%+1

:EndChkHost

For /F "tokens=*" %%J in ('time /t') do set xtime=%%J%mORnot%
@Echo.Stopped: %xdate%%xtime%
Goto :EOF

:MissingFiles
(@Echo.&Echo Can not locate a required file: %1)
Title POSTMACH v%strVersion%: Can't locate a required file
Goto :EOF

:TempTime
::Cheap unique temp time
Set tmptime=
For /F "tokens=*" %%A in ('time /t') do Set tmptime=%%A
If defined tmptime Set tmptime=%tmptime:\=%
If defined tmptime Set tmptime=%tmptime::=%
If defined tmptime Set tmptime=%tmptime:.=%
If defined tmptime Set tmptime=%tmptime:,=%
If defined tmptime Set tmptime=%tmptime: =%
Set %1=%tmptime%
Goto :EOF

:Syntax
Title POSTMACH v%strVersion%: Syntax
For /F "tokens=1* delims=:" %%b in ('findstr /BLI "::! " %~f0') Do @Echo.%%c
Goto :L8R

:Bye
Title POSTMACH v%strVersion%: Finished processing %SvrFile%
If Not Defined TmpProcessFile Goto :L8R
If Exist %TmpProcessFile% Del %TmpProcessFile% >nul 2>&1
:L8R
Endlocal
